library(lme4)
library(lmerTest)

setwd("C:/Users/czp11/Documents/TSPH/TSPH23/TSPH23_wv׋")

Orthodont <- read.table("orthodont.txt", header=T, sep="\t")
attach(Orthodont)

plot(Orthodont[1:4,2:1], ylim=range(Orthodont[,1]), type="b", pch=16, col="blue")
for (i in 2:16) lines(Orthodont[((4*i-3):(4*i)),2:1], type="b", pch=16, col="blue")
for (i in 17:27) lines(Orthodont[((4*i-3):(4*i)),2:1], type="b", pch=16, col="red")

t.test(distance ~ Sex, data=Orthodont[(age==8), ])
t.test(distance ~ Sex, data=Orthodont[(age==10), ])
t.test(distance ~ Sex, data=Orthodont[(age==12), ])
t.test(distance ~ Sex, data=Orthodont[(age==14), ])



diff.distance <- numeric()
for (i in 1:27) {
	diff.distance <- c(diff.distance, distance[4*i-3]-distance[4*i-3])
	diff.distance <- c(diff.distance, distance[4*i-2]-distance[4*i-3])
	diff.distance <- c(diff.distance, distance[4*i-1]-distance[4*i-3])
	diff.distance <- c(diff.distance, distance[4*i]-distance[4*i-3])
}

diff.age <- numeric()
for (i in 1:27) {
	diff.age <- c(diff.age, age[4*i-3]-age[4*i-3])
	diff.age <- c(diff.age, age[4*i-2]-age[4*i-3])
	diff.age <- c(diff.age, age[4*i-1]-age[4*i-3])
	diff.age <- c(diff.age, age[4*i]-age[4*i-3])
}
dat.diff <- cbind.data.frame(diff.distance, diff.age, Orthodont[,3:4])

plot(dat.diff[1:4,2:1], ylim=range(dat.diff[,1]), type="b", pch=16, col="blue", xlab="time difference", "change from base line")
for (i in 2:16) lines(dat.diff[((4*i-3):(4*i)),2:1], type="b", pch=16, col="blue")
for (i in 17:27) lines(dat.diff[((4*i-3):(4*i)),2:1], type="b", pch=16, col="red")

t.test(diff.distance ~ Sex, data=dat.diff[(diff.age==0), ])
t.test(diff.distance ~ Sex, data=dat.diff[(diff.age==2), ])
t.test(diff.distance ~ Sex, data=dat.diff[(diff.age==4), ])
t.test(diff.distance ~ Sex, data=dat.diff[(diff.age==6), ])



### Bonferroni̕@ɂ鑽dr ###

p <- c(0.8805, 0.196, 0.04079)

p.adjust(p, method="bonferroni")

### Holm̕@ɂ鑽dr ###

p.adjust(p, method="holm")



##### ̈ꌳzuU #####

plot(Orthodont[1:4,2:1], ylim=range(Orthodont[,1]), type="b", pch=16, col="blue")
for (i in 2:16) lines(Orthodont[((4*i-3):(4*i)),2:1], type="b", pch=16, col="blue")

Orthodont$age <- as.factor(Orthodont$age)
fit.aov <- aov(distance ~ age + Subject, data=Orthodont, subset = Sex == "Male")

summary(fit.aov)

### Dunnett̕@ɂ鑽dribaselineƊe_̔rj ###

library(multcomp)
fit.dunnett.mc <- glht(fit.aov, linfct = mcp(age = "Dunnett"))
confint(fit.dunnett.mc, level=0.95)
summary(fit.dunnett.mc)



##### ̓񌳔zuU #####

fit.aov2 <- aov(distance ~ age*Sex + Subject, data=Orthodont)
summary(fit.aov2)



##### `ʃf̗ #####
x <- (0:10)
y1 <- 3 - 0.6*x + rnorm(11)
y2 <- 2.5 - 0.3*x + rnorm(11)
y3 <- 2 - 0.1*x + rnorm(11)

plot(x, y1, type="l", ylim=range(c(y1,y2,y3)), ylab="y", col="blue")
points(x, y1, pch=16, col="blue")
abline(3, -0.6, col="blue")
par(new=T)
plot(x, y2, type="l", ylim=range(c(y1,y2,y3)), ylab="y", col="red")
points(x, y2, pch=16, col="red")
abline(2.5, -0.3, col="red")
par(new=T)
plot(x, y3, type="l", ylim=range(c(y1,y2,y3)), ylab="y", col="green")
points(x, y3, pch=16, col="green")
abline(2, -0.1, col="green")

x1 <- rep(0:10, 3)
y <- c(y1, y2, y3)
plot(x1, y, pch=16)
fit <- lm(y ~ x1)
abline(fit)
summary(fit)

item <- c(rep("I", 11), rep("II", 11), rep("III", 11))
Data <- cbind.data.frame(y, x1, item)

library(lme4)

fit.lme0 <- lmer(y ~ x1 + (1 + x1 | item), data=Data)

summary(fit.lme0)



##### `ʃfiFOrthodontf[^j #####

### ʏ̌Œʃf ###
Orthodont$age <- as.numeric(Orthodont$age)
fit.lm <- lm(distance ~ age*Sex, data=Orthodont)
summary(fit.lm)

### ؕЂ_ʃf ###
fit.lme1 <- lmer(distance ~ age * Sex + (1 | Subject), data=Orthodont)
summary(fit.lme1)

### ؕЂƌX_ʃf ###
fit.lme2 <- lmer(distance ~ age * Sex + (1 + age | Subject), data=Orthodont)
summary(fit.lme2)

